#include <libpv.h>
#include <stdio.h>

#include <Python.h>

#include "PvEngine.h"
#include "PvEngineAttr.h"
#include "Pv.h"

PyDoc_STRVAR(module_doc, "This is the libpv module.");

static PyMethodDef Libpv_methods[] = {
#if 0
	{"roj",		xx_roj,		METH_VARARGS, PyDoc_STR("roj(a,b) -> None")},
#endif
	{NULL, NULL}
};

PyMODINIT_FUNC initlibpv(void)
{
	PyObject *m;

	//printf("DEBUG: %s\n", __FUNCTION__);

	/*
	 * Finalize the type object including setting type of the new type
	 * object; doing it here is required for portability to Windows
	 * without requiring C++.
	 */

	if (PyType_Ready(&PvEngine_Type) < 0)
		return;

	if (PyType_Ready(&PvEngineAttr_Type) < 0)
		return;

	if (PyType_Ready(&Pv_Type) < 0)
		return;

	/* create the module and add the functions */
	m = Py_InitModule3("libpv", Libpv_methods, module_doc);
	if (m == NULL)
		return;

	Py_INCREF(&PvEngine_Type);
	Py_INCREF(&PvEngineAttr_Type);
	Py_INCREF(&Pv_Type);

	PyModule_AddObject(m, "PvEngine", (PyObject *)&PvEngine_Type);
	PyModule_AddObject(m, "PvEngineAttr", (PyObject *)&PvEngineAttr_Type);
	PyModule_AddObject(m, "Pv", (PyObject *)&Pv_Type);
}

